Index: /trunk/SophyaPI/PI/Quartz/piwdgquartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/piwdgquartz.cpp	(revision 3747)
+++ /trunk/SophyaPI/PI/Quartz/piwdgquartz.cpp	(revision 3747)
@@ -0,0 +1,306 @@
+/*
+ *  piwdgquartz.cpp
+ *  PI
+ *
+ *  Created by Bruno MANSOUX on Tue Mar 30 2004.
+ *
+ */
+
+#include "piwdgquartz.h"
+
+/* --------------------- Methode ---------------------- */
+PIWdgQuartz::PIWdgQuartz(PIContainerGen *par, const char *nom,int sx, int sy, int px, int py)
+:PIWdgGen(par, nom, sx, sy, px, py) 
+{
+ //   printf ("Create WdgQuartz %s \n",nom);
+    fflush (stdout);
+    title = CFStringCreateWithCString (NULL, nom, kCFStringEncodingMacRoman);
+	viewH = NULL;
+    mFCol = mBCol = PI_NotDefColor;
+}
+
+/* --------------------- Methode ---------------------- */
+PIWdgQuartz::~PIWdgQuartz()
+{
+
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::FinishCreate()
+{
+  finishDone = true;
+  return;
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::SetSize(int sx, int sy)
+{
+    /* Not Yet Implemented */
+    return;
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::SetPos(int px, int py)
+{
+    /* Not Yet Implemented */
+    return;
+}
+
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::SetBorderWidth(int bw)
+{
+    return;
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::SetBackgroundColor(PIColors col)
+{    
+    return;
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::SetForegroundColor(PIColors col)
+{
+    return;
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::EraseWindow(int x0, int y0, int dx, int dy)
+{
+    return;
+}
+
+/* --------------------- Methode ---------------------- */
+PIColors PIWdgQuartz::GetBackgroundColor()
+{
+    return (mBCol);
+}
+ 
+/* --------------------- Methode ---------------------- */
+PIColors PIWdgQuartz::GetForegroundColor()
+{
+    return (mFCol);
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::SetBinding(PIBindingKind left, PIBindingKind top, 
+                    PIBindingKind right, PIBindingKind bottom)
+{
+    return;
+}
+
+/* --------------------- Methode ---------------------- */
+bool PIWdgQuartz::GetBinding(PIBindingKind& left, PIBindingKind& top, 
+                    PIBindingKind& right, PIBindingKind& bottom)
+{
+    return false;
+}
+
+/* --------------------- Methode ---------------------- */
+int PIWdgQuartz::XSize()
+{
+    return(wdgRect.bottom-wdgRect.top);
+}
+
+/* --------------------- Methode ---------------------- */
+int PIWdgQuartz::YSize()
+{
+    return(wdgRect.right-wdgRect.left);
+}
+
+/* --------------------- Methode ---------------------- */
+int PIWdgQuartz::XPos()
+{
+    return((wdgRect.bottom+wdgRect.top)/2);
+}
+
+/* --------------------- Methode ---------------------- */
+int PIWdgQuartz::YPos()
+{
+    return((wdgRect.right+wdgRect.left)/2);
+}
+
+
+/* --------------------- Methode ---------------------- */
+string PIWdgQuartz::Nom()
+{
+    char* cTitle;
+    string cppTitle;
+
+    cTitle = (char *)CFStringGetCStringPtr(title, kCFStringEncodingMacRoman);
+    
+    cppTitle = cTitle;
+    return (cppTitle);
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::GetScreenPos(int & spx, int & spy)
+{
+    spx = 0; spy = 0;
+    return ;
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::Manage()
+{
+    return;
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::UnManage()
+{
+    return;
+}
+
+/* --------------------- Methode ---------------------- */
+bool PIWdgQuartz::IfManaged()
+{
+    return true;
+}
+
+/* --------------------- Methode ---------------------- */
+bool PIWdgQuartz::IsVisible()
+{
+    return true;
+}
+
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::Refresh()
+{
+    return;
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::SetSensitive()
+{
+    return;
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::SetUnSensitive()
+{
+    return;
+}
+
+/* --------------------- Methode ---------------------- */
+bool PIWdgQuartz::IfSensitive()
+{
+    return true;
+}
+
+
+//  Gestion de copier-coller
+/* --------------------- Methode ---------------------- */
+bool PIWdgQuartz::ClaimSelection(unsigned int typ)
+{
+    return true;
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::SelectionLost()
+{
+    return;
+}
+
+/* --------------------- Methode ---------------------- */
+unsigned int   PIWdgQuartz::RequestSelection(unsigned int typ)
+{
+    return (typ);
+}
+
+/* --------------------- Methode ---------------------- */
+void* PIWdgQuartz::ProvideSelection(unsigned int& typ, unsigned int& len)
+{
+    return NULL;
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::SelectionTransferEnd()
+{
+    return;
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::PasteSelection(unsigned int typ, void *, unsigned int l)
+{
+    return;
+}
+
+//  Copie depuis un PIWdgGen
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::CopyFrom(PIWdgGen* wdg, int ox, int oy, int dx, int dy, int x, int y)
+{
+    return;
+}
+
+//  Gestion des EventHandler
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::AddDrawHandler(PIEventHandler* drwh, bool ad)
+{
+/*
+    if (contH)
+    {
+        InstallControlEventHandler (contH, 
+                                    NewEventHandlerUPP (drwh),
+                                    GetEventTypeCount(drawEvents),
+                                    drawEvents,
+                                    contH,
+                                    NULL);
+    }
+    if(wPtr)
+    {
+        InstallWindowEventHandler (wPtr, 
+                                    NewEventHandlerUPP (drwh),
+                                    GetEventTypeCount(drawEvents),
+                                    drawEvents,
+                                    wPtr,
+                                    NULL);
+        
+    }
+*/
+    return;
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::RemoveDrawHandler(PIEventHandler* drwh)
+{
+    RemoveEventHandler(drwh);
+    return;
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::AddEventHandler(PIEventHandler* evh, unsigned long evtmask, bool ad)
+{
+/*
+    InstallControlEventHandler (contH, 
+                                NewEventHandlerUPP (evh),
+                                GetEventTypeCount(evtmask),
+                                evtmask,
+                                contH,
+                                NULL);
+*/
+    return;
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::RemoveEventHandler(PIEventHandler* evh)
+{
+    RemoveEventHandler(evh);
+    return;
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::CallDrawHandlers(int x0, int y0, int dx, int dy)
+{
+    return;
+}
+
+/* --------------------- Methode ---------------------- */
+void PIWdgQuartz::CallEventHandlers(unsigned long evt, int px, int py,
+                                    int k, int km, unsigned long tm)
+{
+    return;
+}
+
Index: /trunk/SophyaPI/PI/Quartz/piwdgquartz.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/piwdgquartz.h	(revision 3747)
+++ /trunk/SophyaPI/PI/Quartz/piwdgquartz.h	(revision 3747)
@@ -0,0 +1,131 @@
+/*
+ *  piwdgmosx.h
+ *  PI
+ *
+ *  Created by Bruno MANSOUX on Tue Mar 30 2004.
+ *
+ */
+
+#include <Carbon/Carbon.h>
+
+#ifndef PIWDG_QUARTZ_SEEN
+#define PIWDG_QUARTZ_SEEN
+
+#include "piwdggen.h"
+
+
+/*
+EventTypeSpec drawEvents[] = {{kEventClassControl, kEventControlDraw},
+                            {kEventClassWindow,kEventWindowDrawFrame},
+                            {kEventClassWindow,kEventWindowDrawPart},
+                            };
+
+*/
+
+
+class PIWdgQuartz : public PIWdgGen 
+{
+public:
+// Les methodes ...
+        PIWdgQuartz(PIContainerGen *par, const char *nom, 
+                int sx=10, int sy=10, int px=0, int py=0);
+
+  virtual 	 ~PIWdgQuartz();
+
+  virtual void	 FinishCreate(); // apres avoir installe les sous-vues
+
+  virtual void   SetSize(int sx, int sy);
+  virtual void   SetPos(int px, int py);
+  virtual void   SetBorderWidth(int bw);
+
+
+//  Divers : couleur de fond, et d'avant plan Effacement fenetre,
+  virtual void           SetBackgroundColor(PIColors col=PI_White);
+  virtual void           SetForegroundColor(PIColors col=PI_Black);
+  virtual void           EraseWindow(int x0=0, int y0=0, int dx=0, int dy=0);
+  virtual PIColors       GetBackgroundColor();
+  virtual PIColors       GetForegroundColor();
+
+  virtual void   SetBinding(PIBindingKind left, PIBindingKind top, 
+                            PIBindingKind right, PIBindingKind bottom);
+  virtual bool   GetBinding(PIBindingKind& left, PIBindingKind& top, 
+                            PIBindingKind& right, PIBindingKind& bottom);
+
+  virtual int    XSize();
+  virtual int    YSize();
+  virtual int    XPos();
+  virtual int    YPos();
+
+  virtual string Nom();  
+  virtual void   GetScreenPos(int & spx, int & spy);
+
+  virtual void   Manage();
+  virtual void   UnManage();
+  virtual bool   IfManaged();
+  virtual bool   IsVisible();
+
+//  Fonction qui doit etre appelee pour rafraichir la fenetre 
+  virtual void       	 Refresh();
+
+//  Pour rendre un composant graphique (PIWdg) sensible/insensible 
+  virtual void           SetSensitive();
+  virtual void           SetUnSensitive();
+  virtual bool           IfSensitive();
+
+//  Gestion de copier-coller
+  virtual bool           ClaimSelection(unsigned int typ=PICP_string);
+  virtual void           SelectionLost();
+  virtual unsigned int   RequestSelection(unsigned int typ=PICP_string);
+  virtual void*          ProvideSelection(unsigned int& typ, unsigned int& len);
+  virtual void           SelectionTransferEnd();
+  virtual void           PasteSelection(unsigned int typ, void *, unsigned int l);
+
+//  Copie depuis un PIWdgGen
+  virtual void		 CopyFrom(PIWdgGen* wdg, int ox, int oy, int dx, int dy, int x, int y);
+
+//  Gestion des EventHandler
+  virtual void		 AddDrawHandler(PIEventHandler* drwh, bool ad=false);
+  virtual void		 RemoveDrawHandler(PIEventHandler* drwh);
+  virtual void		 AddEventHandler(PIEventHandler* evh, unsigned long evtmask, bool ad=false);
+  virtual void		 RemoveEventHandler(PIEventHandler* evh);
+
+// En public, pour permettre l'acces depuis call-back Xt
+  virtual void		 CallDrawHandlers(int x0, int y0, int dx, int dy); 
+  virtual void		 CallEventHandlers(unsigned long evt, int px, int py,
+                                           int k, int km, unsigned long tm);
+
+	/*
+	ControlRef GetControlRef() {return contH;}
+	WindowPtr GetWindowPtr() {return wPtr;}
+	WindowPtr GetWindowParent() {return wParent;}
+	*/
+	
+	HIViewRef GetHIViewRef() {return viewH;}
+
+protected:
+    Rect	wdgRect;
+    CFStringRef	title;
+	HIViewRef	viewH;
+//  pas utilisable dans MOSX/Carbon
+    PIColors mFCol, mBCol;
+};
+
+typedef PIWdgQuartz PIWdg;
+
+
+// -------- La classe PIScreenBuffer ----------
+class PIScreenBuffer {
+public :
+  			PIScreenBuffer(int sx, int sy) {};
+  virtual	~PIScreenBuffer() {};
+
+  virtual int       XSize()	 {return 0;};
+  virtual int       YSize()  {return 0;};
+  virtual  void 	CopyFromWdg(PIWdg* wdg, int ox, int oy, int dx, int dy, int x, int y) {};
+  virtual  void 	CopyToWdg(PIWdg* wdg, int ox, int oy, int dx, int dy, int x, int y) {};
+  virtual  void 	CopyFrom(PIScreenBuffer* grb, int ox, int oy, int dx, int dy, int x, int y) {};
+
+};
+
+#endif/* PIWDG_QUARTZ_SEEN */
+
